source: installer/opengnsys_installer.sh @ ea01a0db

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since ea01a0db was 9e64d82, checked in by Ramón M. Gómez <ramongomez@…>, 7 years ago

#869: Adaptación de paquetes en Ubuntu 18.04 y evitar redundancias al detectar parámetros de red.

  • Property mode set to 100755
File size: 58.7 KB
Line 
1#!/bin/bash
2
3#####################################################################
4####### Script instalador OpenGnsys
5####### Autor: Luis Guillén <lguillen@unizar.es>
6#####################################################################
7
8
9####  AVISO: Puede editar configuración de acceso por defecto.
10####  WARNING: Edit default access configuration if you wish.
11DEFAULT_MYSQL_ROOT_PASSWORD="passwordroot"      # Clave por defecto root de MySQL
12DEFAULT_OPENGNSYS_DB_USER="usuog"               # Usuario por defecto de acceso a la base de datos
13DEFAULT_OPENGNSYS_DB_PASSWD="passusuog"         # Clave por defecto de acceso a la base de datos
14DEFAULT_OPENGNSYS_CLIENT_PASSWD="og"            # Clave por defecto de acceso del cliente       
15
16# Sólo ejecutable por usuario root
17if [ "$(whoami)" != 'root' ]; then
18        echo "ERROR: this program must run under root privileges!!"
19        exit 1
20fi
21
22echo -e "\\nOpenGnsys Installation"
23echo "=============================="
24
25# Clave root de MySQL
26while : ; do
27        echo -n -e "\\nEnter root password for MySQL (${DEFAULT_MYSQL_ROOT_PASSWORD}): ";
28        read -r MYSQL_ROOT_PASSWORD
29        if [ -n "${MYSQL_ROOT_PASSWORD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
30                echo -e "\\aERROR: Must be alphanumeric, try again..."
31        else
32                # Si esta vacio ponemos el valor por defecto
33                MYSQL_ROOT_PASSWORD="${MYSQL_ROOT_PASSWORD:-$DEFAULT_MYSQL_ROOT_PASSWORD}"
34                break
35        fi
36done
37
38# Usuario de acceso a la base de datos
39while : ; do
40        echo -n -e "\\nEnter username for OpenGnsys console (${DEFAULT_OPENGNSYS_DB_USER}): "
41        read -r OPENGNSYS_DB_USER
42        if [ -n "${OPENGNSYS_DB_USER//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
43                echo -e "\\aERROR: Must be alphanumeric, try again..."
44        else
45                # Si esta vacio ponemos el valor por defecto
46                OPENGNSYS_DB_USER="${OPENGNSYS_DB_USER:-$DEFAULT_OPENGNSYS_DB_USER}"
47                break
48        fi
49done
50
51# Clave de acceso a la base de datos
52while : ; do
53        echo -n -e "\\nEnter password for OpenGnsys console (${DEFAULT_OPENGNSYS_DB_PASSWD}): "
54        read -r OPENGNSYS_DB_PASSWD
55        if [ -n "${OPENGNSYS_DB_PASSWD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
56                echo -e "\\aERROR: Must be alphanumeric, try again..."
57        else
58                # Si esta vacio ponemos el valor por defecto
59                OPENGNSYS_DB_PASSWD="${OPENGNSYS_DB_PASSWD:-$DEFAULT_OPENGNSYS_DB_PASSWD}"
60                break
61        fi
62done
63
64# Clave de acceso del cliente
65while : ; do
66        echo -n -e "\\nEnter root password for OpenGnsys client (${DEFAULT_OPENGNSYS_CLIENT_PASSWD}): "
67        read -r OPENGNSYS_CLIENT_PASSWD
68        if [ -n "${OPENGNSYS_CLIENT_PASSWD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
69                echo -e "\\aERROR: Must be alphanumeric, try again..."
70        else
71                # Si esta vacio ponemos el valor por defecto
72                OPENGNSYS_CLIENT_PASSWD="${OPENGNSYS_CLIENT_PASSWD:-$DEFAULT_OPENGNSYS_CLIENT_PASSWD}"
73                break
74        fi
75done
76
77# Selección de clientes ogLive para descargar.
78while : ; do
79        echo -e "\\nChoose ogLive client to install."
80        echo -e "1) Kernel 4.13, 64-bit, EFI-compatible"
81        echo -e "2) Kernel 3.2, 32-bit"
82        echo -e "3) Both"
83        echo -n -e "Please, type a valid number (1): "
84        read -r OPT
85        case "$OPT" in
86                1|"")   OGLIVE="ogLive-xenial-4.13.0-17-generic-amd64-r5520.iso"
87                        break ;;
88                2)      OGLIVE="ogLive-precise-3.2.0-23-generic-r5159.iso"
89                        break ;;
90                3)      OGLIVE="ogLive-xenial-4.13.0-17-generic-amd64-r5520.iso ogLive-precise-3.2.0-23-generic-r5159.iso";
91                        break ;;
92                *)      echo -e "\\aERROR: unknown option, try again."
93        esac
94done
95
96echo -e "\\n=============================="
97
98# Comprobar si se ha descargado el paquete comprimido (REMOTE=0) o sólo el instalador (REMOTE=1).
99PROGRAMDIR=$(readlink -e "$(dirname "$0")")
100PROGRAMNAME=$(basename "$0")
101OPENGNSYS_SERVER="opengnsys.es"
102DOWNLOADURL="https://$OPENGNSYS_SERVER/trac/downloads"
103if [ -d "$PROGRAMDIR/../installer" ]; then
104        REMOTE=0
105else
106        REMOTE=1
107fi
108BRANCH="devel"
109CODE_URL="https://codeload.github.com/opengnsys/OpenGnsys/zip/$BRANCH"
110API_URL="https://api.github.com/repos/opengnsys/OpenGnsys/branches/$BRANCH"
111
112WORKDIR=/tmp/opengnsys_installer
113mkdir -p $WORKDIR
114
115# Directorio destino de OpenGnsys.
116INSTALL_TARGET=/opt/opengnsys
117PATH=$PATH:$INSTALL_TARGET/bin
118
119# Registro de incidencias.
120OGLOGFILE=$INSTALL_TARGET/log/${PROGRAMNAME%.sh}.log
121LOG_FILE=/tmp/$(basename $OGLOGFILE)
122
123# Usuario del cliente para acceso remoto.
124OPENGNSYS_CLIENT_USER="opengnsys"
125
126# Nombre de la base datos y fichero SQL para su creación.
127OPENGNSYS_DATABASE="ogAdmBD"
128OPENGNSYS_DB_CREATION_FILE=opengnsys/admin/Database/${OPENGNSYS_DATABASE}.sql
129
130
131#####################################################################
132####### Funciones de configuración
133#####################################################################
134
135# Generar variables de configuración del instalador
136# Variables globales:
137# - OSDISTRIB, OSVERSION - tipo y versión de la distribución GNU/Linux
138# - DEPENDENCIES - array de dependencias que deben estar instaladas
139# - UPDATEPKGLIST, INSTALLPKGS, CHECKPKGS - comandos para gestión de paquetes
140# - INSTALLEXTRADEPS - instalar dependencias no incluidas en la distribución
141# - STARTSERVICE, ENABLESERVICE - iniciar y habilitar un servicio
142# - STOPSERVICE, DISABLESERVICE - parar y deshabilitar un servicio
143# - APACHESERV, APACHECFGDIR, APACHESITESDIR, APACHEUSER, APACHEGROUP - servicio y configuración de Apache
144# - APACHESSLMOD, APACHEENABLESSL, APACHEMAKECERT - habilitar módulo Apache y certificado SSL
145# - APACHEENABLEOG, APACHEOGSITE, - habilitar sitio web de OpenGnsys
146# - INETDSERV - servicio Inetd
147# - FIREWALLSERV - servicio de cortabuegos IPTables/FirewallD
148# - DHCPSERV, DHCPCFGDIR - servicio y configuración de DHCP
149# - MYSQLSERV, TMPMYCNF - servicio MySQL y fichero temporal con credenciales de acceso
150# - MARIADBSERV - servicio MariaDB (sustituto de MySQL en algunas distribuciones)
151# - RSYNCSERV, RSYNCCFGDIR - servicio y configuración de Rsync
152# - SAMBASERV, SAMBACFGDIR - servicio y configuración de Samba
153# - TFTPSERV, TFTPCFGDIR - servicio y configuración de TFTP/PXE
154function autoConfigure()
155{
156# Detectar sistema operativo del servidor (compatible con fichero os-release y con LSB).
157if [ -f /etc/os-release ]; then
158        source /etc/os-release
159        OSDISTRIB="$ID"
160        OSVERSION="$VERSION_ID"
161else
162        OSDISTRIB=$(lsb_release -is 2>/dev/null)
163        OSVERSION=$(lsb_release -rs 2>/dev/null)
164fi
165# Convertir distribución a minúsculas y obtener solo el 1er número de versión.
166OSDISTRIB="${OSDISTRIB,,}"
167OSVERSION="${OSVERSION%%.*}"
168
169# Configuración según la distribución GNU/Linux (usar minúsculas).
170case "$OSDISTRIB" in
171        ubuntu|debian|linuxmint)
172                DEPENDENCIES=( subversion apache2 php php-ldap libapache2-mod-php mysql-server php-mysql isc-dhcp-server bittorrent tftp-hpa tftpd-hpa xinetd build-essential g++-multilib libmysqlclient-dev wget curl doxygen graphviz bittornado ctorrent samba rsync unzip netpipes debootstrap schroot squashfs-tools btrfs-tools procps arp-scan realpath php-curl gettext moreutils jq wakeonlan udpcast shim-signed grub-efi-amd64-signed )
173                UPDATEPKGLIST="apt-get update"
174                INSTALLPKG="apt-get -y install --force-yes"
175                CHECKPKG="dpkg -s \$package 2>/dev/null | grep Status | grep -qw install"
176                if which service &>/dev/null; then
177                        STARTSERVICE="eval service \$service restart"
178                        STOPSERVICE="eval service \$service stop"
179                else
180                        STARTSERVICE="eval /etc/init.d/\$service restart"
181                        STOPSERVICE="eval /etc/init.d/\$service stop"
182                fi
183                ENABLESERVICE="eval update-rc.d \$service defaults"
184                DISABLESERVICE="eval update-rc.d \$service disable"
185                APACHESERV=apache2
186                APACHECFGDIR=/etc/apache2
187                APACHESITESDIR=sites-available
188                APACHEOGSITE=opengnsys
189                APACHEUSER="www-data"
190                APACHEGROUP="www-data"
191                APACHESSLMOD="a2enmod ssl"
192                APACHEREWRITEMOD="a2enmod rewrite"
193                APACHEENABLESSL="a2ensite default-ssl"
194                APACHEENABLEOG="a2ensite $APACHEOGSITE"
195                APACHEMAKECERT="make-ssl-cert generate-default-snakeoil --force-overwrite"
196                DHCPSERV=isc-dhcp-server
197                DHCPCFGDIR=/etc/dhcp
198                INETDSERV=xinetd
199                INETDCFGDIR=/etc/xinetd.d
200                MYSQLSERV=mysql
201                MARIADBSERV=mariadb
202                RSYNCSERV=rsync
203                RSYNCCFGDIR=/etc
204                SAMBASERV=smbd
205                SAMBACFGDIR=/etc/samba
206                TFTPCFGDIR=/var/lib/tftpboot
207                ;;
208        fedora|centos)
209                DEPENDENCIES=( subversion httpd mod_ssl php php-ldap mysql-server mysql-devel mysql-devel.i686 php-mysql dhcp tftp-server tftp xinetd binutils gcc gcc-c++ glibc-devel glibc-devel.i686 glibc-static glibc-static.i686 libstdc++-devel.i686 make wget curl doxygen graphviz ctorrent samba samba-client rsync unzip debootstrap schroot squashfs-tools python-crypto arp-scan procps-ng gettext moreutils jq net-tools http://ftp.altlinux.org/pub/distributions/ALTLinux/5.1/branch/$(arch)/RPMS.classic/netpipes-4.2-alt1.$(arch).rpm )
210                INSTALLEXTRADEPS=( 'pushd /tmp; wget -t3 http://download.bittornado.com/download/BitTornado-0.3.18.tar.gz && tar xvzf BitTornado-0.3.18.tar.gz && cd BitTornado-CVS && python setup.py install && ln -fs btlaunchmany.py /usr/bin/btlaunchmany && ln -fs bttrack.py /usr/bin/bttrack; popd' )
211                INSTALLPKG="yum install -y libstdc++ libstdc++.i686"
212                CHECKPKG="rpm -q --quiet \$package"
213                SYSTEMD=$(which systemctl 2>/dev/null)
214                if [ -n "$SYSTEMD" ]; then
215                        STARTSERVICE="eval systemctl start \$service.service"
216                        STOPSERVICE="eval systemctl stop \$service.service"
217                        ENABLESERVICE="eval systemctl enable \$service.service"
218                        DISABLESERVICE="eval systemctl disable \$service.service"
219                else
220                        STARTSERVICE="eval service \$service start"
221                        STOPSERVICE="eval service \$service stop"
222                        ENABLESERVICE="eval chkconfig \$service on"
223                        DISABLESERVICE="eval chkconfig \$service off"
224                fi
225                APACHESERV=httpd
226                APACHECFGDIR=/etc/httpd/conf.d
227                APACHEOGSITE=opengnsys.conf
228                APACHEUSER="apache"
229                APACHEGROUP="apache"
230                APACHEREWRITEMOD="sed -i '/rewrite/s/^#//' $APACHECFGDIR/../*.conf"
231                DHCPSERV=dhcpd
232                DHCPCFGDIR=/etc/dhcp
233                if firewall-cmd --state &>/dev/null; then
234                        FIREWALLSERV=firewalld
235                else
236                        FIREWALLSERV=iptables
237                fi
238                INETDSERV=xinetd
239                INETDCFGDIR=/etc/xinetd.d
240                MYSQLSERV=mysqld
241                MARIADBSERV=mariadb
242                RSYNCSERV=rsync
243                RSYNCCFGDIR=/etc
244                SAMBASERV=smb
245                SAMBACFGDIR=/etc/samba
246                TFTPSERV=tftp
247                TFTPCFGDIR=/var/lib/tftpboot
248                ;;
249        "")     echo "ERROR: Unknown Linux distribution, please install \"lsb_release\" command."
250                exit 1 ;;
251        *)      echo "ERROR: Distribution not supported by OpenGnsys."
252                exit 1 ;;
253esac
254
255# Fichero de credenciales de acceso a MySQL.
256TMPMYCNF=/tmp/.my.cnf.$$
257}
258
259
260# Modificar variables de configuración tras instalar paquetes del sistema.
261function autoConfigurePost()
262{
263local f
264
265# Configuraciones específicas para Samba y TFTP en Debian 6.
266[ -z "$SYSTEMD" -a ! -e /etc/init.d/$SAMBASERV ] && SAMBASERV=samba
267[ ! -e $TFTPCFGDIR ] && TFTPCFGDIR=/srv/tftp
268
269# Configuraciones específicas para SELinux permisivo en distintas versiones.
270[ -f /selinux/enforce ] && echo 0 > /selinux/enforce
271for f in /etc/sysconfig/selinux /etc/selinux/config; do
272        [ -f $f ] && perl -pi -e 's/SELINUX=enforcing/SELINUX=permissive/g' $f
273done
274selinuxenabled 2>/dev/null && setenforce 0 2>/dev/null
275}
276
277
278# Cargar lista de paquetes del sistema y actualizar algunas variables de configuración
279# dependiendo de la versión instalada.
280function updatePackageList()
281{
282local DHCPVERSION PHP7VERSION
283
284# Si es necesario, actualizar la lista de paquetes disponibles.
285[ -n "$UPDATEPKGLIST" ] && eval $UPDATEPKGLIST
286
287# Configuración personallizada de algunos paquetes.
288case "$OSDISTRIB" in
289        ubuntu|linuxmint)       # Postconfiguación personalizada para Ubuntu.
290                # Configuración para DHCP v3.
291                DHCPVERSION=$(apt-cache show $(apt-cache pkgnames|egrep "dhcp.?-server$") | \
292                              awk '/Version/ {print substr($2,1,1);}' | \
293                              sort -n | tail -1)
294                if [ $DHCPVERSION = 3 ]; then
295                        DEPENDENCIES=( ${DEPENDENCIES[@]/isc-dhcp-server/dhcp3-server} )
296                        DHCPSERV=dhcp3-server
297                        DHCPCFGDIR=/etc/dhcp3
298                fi
299                # Configuración para PHP 7 en Ubuntu.
300                if [ -z "$(apt-cache pkgnames php7)" ]; then
301                        eval $INSTALLPKG software-properties-common
302                        add-apt-repository -y ppa:ondrej/php
303                        eval $UPDATEPKGLIST
304                        PHP7VERSION=$(apt-cache pkgnames php7 | sort | head -1)
305                        DEPENDENCIES=( ${DEPENDENCIES[@]//php/$PHP7VERSION} )
306                fi
307                # Adaptar dependencias para libmysqlclient.
308                [ -z "$(apt-cache pkgnames libmysqlclient-dev)" ] && [ -n "$(apt-cache pkgnames libmysqlclient15)" ] && DEPENDENCIES=( ${DEPENDENCIES[@]//libmysqlclient-dev/libmysqlclient15} )
309                # Paquete correcto para realpath.
310                [ -z "$(apt-cache pkgnames realpath)" ] && DEPENDENCIES=( ${DEPENDENCIES[@]//realpath/coreutils} )
311                ;;
312        centos) # Postconfiguación personalizada para CentOS.
313                # Configuración para PHP 7.
314                if ! yum list php7 &>/dev/null; then
315                        if [ $OSVERSION -lt 7 ]; then
316                                yum install -y https://mirror.webtatic.com/yum/el$OSVERSION/latest.rpm
317                                PHP7VERSION=$(yum list -q php7\*w | awk -F. '/^php/ {p=$1} END {print p}')
318                                DEPENDENCIES=( ${DEPENDENCIES[@]//php/$PHP5VERSION} )
319                        fi
320                fi
321                # Cambios a aplicar a partir de CentOS 7.
322                if [ $OSVERSION -ge 7 ]; then
323                        # Sustituir MySQL por MariaDB.
324                        DEPENDENCIES=( ${DEPENDENCIES[*]/mysql-/mariadb-} )
325                        # Instalar ctorrent de EPEL para CentOS 6 (no disponible en CentOS 7).
326                        DEPENDENCIES=( ${DEPENDENCIES[*]/ctorrent/http://dl.fedoraproject.org/pub/epel/6/$(arch)/Packages/c/ctorrent-1.3.4-14.dnh3.3.2.el6.$(arch).rpm} )
327                fi
328                ;;
329        fedora) # Postconfiguación personalizada para Fedora.
330                # Incluir paquetes específicos.
331                DEPENDENCIES=( ${DEPENDENCIES[@]} btrfs-progs )
332                # Sustituir MySQL por MariaDB a partir de Fedora 20.
333                [ $OSVERSION -ge 20 ] && DEPENDENCIES=( ${DEPENDENCIES[*]/mysql-/mariadb-} )
334                ;;
335esac
336}
337
338
339#####################################################################
340####### Algunas funciones útiles de propósito general:
341#####################################################################
342
343function getDateTime()
344{
345        date "+%Y%m%d-%H%M%S"
346}
347
348# Escribe a fichero y muestra por pantalla
349function echoAndLog()
350{
351        local DATETIME=`getDateTime`
352        echo "$1"
353        echo "$DATETIME;$SSH_CLIENT;$1" >> $LOG_FILE
354}
355
356# Escribe a fichero y muestra mensaje de error
357function errorAndLog()
358{
359        local DATETIME=`getDateTime`
360        echo "ERROR: $1"
361        echo "$DATETIME;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
362}
363
364# Escribe a fichero y muestra mensaje de aviso
365function warningAndLog()
366{
367        local DATETIME=`getDateTime`
368        echo "Warning: $1"
369        echo "$DATETIME;$SSH_CLIENT;Warning: $1" >> $LOG_FILE
370}
371
372# Comprueba si el elemento pasado en $2 está en el array $1
373function isInArray()
374{
375        if [ $# -ne 2 ]; then
376                errorAndLog "${FUNCNAME}(): invalid number of parameters"
377                exit 1
378        fi
379
380        local deps
381        local is_in_array=1
382        local element="$2"
383
384        echoAndLog "${FUNCNAME}(): checking if $2 is in $1"
385        eval "deps=( \"\${$1[@]}\" )"
386
387        # Copia local del array del parámetro 1.
388        for (( i = 0 ; i < ${#deps[@]} ; i++ )); do
389                if [ "${deps[$i]}" = "${element}" ]; then
390                        echoAndLog "isInArray(): $element found in array"
391                        is_in_array=0
392                fi
393        done
394
395        if [ $is_in_array -ne 0 ]; then
396                echoAndLog "${FUNCNAME}(): $element NOT found in array"
397        fi
398
399        return $is_in_array
400}
401
402
403#####################################################################
404####### Funciones de manejo de paquetes Debian
405#####################################################################
406
407function checkPackage()
408{
409        package=$1
410        if [ -z $package ]; then
411                errorAndLog "${FUNCNAME}(): parameter required"
412                exit 1
413        fi
414        echoAndLog "${FUNCNAME}(): checking if package $package exists"
415        eval $CHECKPKG
416        if [ $? -eq 0 ]; then
417                echoAndLog "${FUNCNAME}(): package $package exists"
418                return 0
419        else
420                echoAndLog "${FUNCNAME}(): package $package doesn't exists"
421                return 1
422        fi
423}
424
425# Recibe array con dependencias
426# por referencia deja un array con las dependencias no resueltas
427# devuelve 1 si hay alguna dependencia no resuelta
428function checkDependencies()
429{
430        if [ $# -ne 2 ]; then
431                errorAndLog "${FUNCNAME}(): invalid number of parameters"
432                exit 1
433        fi
434
435        echoAndLog "${FUNCNAME}(): checking dependences"
436        uncompletedeps=0
437
438        # copia local del array del parametro 1
439        local deps
440        eval "deps=( \"\${$1[@]}\" )"
441
442        declare -a local_notinstalled
443
444        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
445        do
446                checkPackage ${deps[$i]}
447                if [ $? -ne 0 ]; then
448                        local_notinstalled[$uncompletedeps]=$package
449                        let uncompletedeps=uncompletedeps+1
450                fi
451        done
452
453        # relleno el array especificado en $2 por referencia
454        for (( i = 0 ; i < ${#local_notinstalled[@]} ; i++ ))
455        do
456                eval "${2}[$i]=${local_notinstalled[$i]}"
457        done
458
459        # retorna el numero de paquetes no resueltos
460        echoAndLog "${FUNCNAME}(): dependencies uncompleted: $uncompletedeps"
461        return $uncompletedeps
462}
463
464# Recibe un array con las dependencias y lo instala
465function installDependencies()
466{
467        if [ $# -ne 1 ]; then
468                errorAndLog "${FUNCNAME}(): invalid number of parameters"
469                exit 1
470        fi
471        echoAndLog "${FUNCNAME}(): installing uncompleted dependencies"
472
473        # copia local del array del parametro 1
474        local deps
475        eval "deps=( \"\${$1[@]}\" )"
476
477        local string_deps=""
478        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
479        do
480                string_deps="$string_deps ${deps[$i]}"
481        done
482
483        if [ -z "${string_deps}" ]; then
484                errorAndLog "${FUNCNAME}(): array of dependeces is empty"
485                exit 1
486        fi
487
488        OLD_DEBIAN_FRONTEND=$DEBIAN_FRONTEND            # Debian/Ubuntu
489        export DEBIAN_FRONTEND=noninteractive
490
491        echoAndLog "${FUNCNAME}(): now $string_deps will be installed"
492        eval $INSTALLPKG $string_deps
493        if [ $? -ne 0 ]; then
494                errorAndLog "${FUNCNAME}(): error installing dependencies"
495                return 1
496        fi
497
498        DEBIAN_FRONTEND=$OLD_DEBIAN_FRONTEND            # Debian/Ubuntu
499        test grep -q "EPEL temporal" /etc/yum.repos.d/epel.repo 2>/dev/null || mv -f /etc/yum.repos.d/epel.repo.rpmnew /etc/yum.repos.d/epel.repo 2>/dev/null   # CentOS/RedHat EPEL
500
501        echoAndLog "${FUNCNAME}(): dependencies installed"
502}
503
504# Hace un backup del fichero pasado por parámetro
505# deja un -last y uno para el día
506function backupFile()
507{
508        if [ $# -ne 1 ]; then
509                errorAndLog "${FUNCNAME}(): invalid number of parameters"
510                exit 1
511        fi
512
513        local file="$1"
514        local dateymd=`date +%Y%m%d`
515
516        if [ ! -f "$file" ]; then
517                warningAndLog "${FUNCNAME}(): file $file doesn't exists"
518                return 1
519        fi
520
521        echoAndLog "${FUNCNAME}(): making $file backup"
522
523        # realiza una copia de la última configuración como last
524        cp -a "$file" "${file}-LAST"
525
526        # si para el día no hay backup lo hace, sino no
527        if [ ! -f "${file}-${dateymd}" ]; then
528                cp -a "$file" "${file}-${dateymd}"
529        fi
530
531        echoAndLog "${FUNCNAME}(): $file backup success"
532}
533
534#####################################################################
535####### Funciones para el manejo de bases de datos
536#####################################################################
537
538# This function set password to root
539function mysqlSetRootPassword()
540{
541        if [ $# -ne 1 ]; then
542                errorAndLog "${FUNCNAME}(): invalid number of parameters"
543                exit 1
544        fi
545
546        local root_mysql="$1"
547        echoAndLog "${FUNCNAME}(): setting root password in MySQL server"
548        mysqladmin -u root password "$root_mysql"
549        if [ $? -ne 0 ]; then
550                errorAndLog "${FUNCNAME}(): error while setting root password in MySQL server"
551                return 1
552        fi
553        echoAndLog "${FUNCNAME}(): root password saved!"
554        return 0
555}
556
557# Si el servicio mysql esta ya instalado cambia la variable de la clave del root por la ya existente
558function mysqlGetRootPassword()
559{
560        local pass_mysql
561        local pass_mysql2
562        # Comprobar si MySQL está instalado con la clave de root por defecto.
563        if mysql -u root -p"$MYSQL_ROOT_PASSWORD" <<<"quit" 2>/dev/null; then
564                echoAndLog "${FUNCNAME}(): Using default mysql root password."
565        else
566                stty -echo
567                echo "There is a MySQL service already installed."
568                read -p "Enter MySQL root password: " pass_mysql
569                echo ""
570                read -p "Confrim password:" pass_mysql2
571                echo ""
572                stty echo
573                if [ "$pass_mysql" == "$pass_mysql2" ] ;then
574                        MYSQL_ROOT_PASSWORD="$pass_mysql"
575                        return 0
576                else
577                        echo "The keys don't match. Do not configure the server's key,"
578                        echo "transactions in the database will give error."
579                        return 1
580                fi
581        fi
582}
583
584# comprueba si puede conectar con mysql con el usuario root
585function mysqlTestConnection()
586{
587        if [ $# -ne 1 ]; then
588                errorAndLog "${FUNCNAME}(): invalid number of parameters"
589                exit 1
590        fi
591
592        local root_password="$1"
593        echoAndLog "${FUNCNAME}(): checking connection to mysql..."
594        # Componer fichero con credenciales de conexión a MySQL.
595        touch $TMPMYCNF
596        chmod 600 $TMPMYCNF
597        cat << EOT > $TMPMYCNF
598[client]
599user=root
600password=$root_password
601EOT
602        # Borrar el fichero temporal si termina el proceso de instalación.
603        trap "rm -f $TMPMYCNF" 0 1 2 3 6 9 15
604        # Comprobar conexión a MySQL.
605        echo "" | mysql --defaults-extra-file=$TMPMYCNF
606        if [ $? -ne 0 ]; then
607                errorAndLog "${FUNCNAME}(): connection to mysql failed, check root password and if daemon is running!"
608                return 1
609        else
610                echoAndLog "${FUNCNAME}(): connection success"
611                return 0
612        fi
613}
614
615# comprueba si la base de datos existe
616function mysqlDbExists()
617{
618        if [ $# -ne 1 ]; then
619                errorAndLog "${FUNCNAME}(): invalid number of parameters"
620                exit 1
621        fi
622
623        local database="$1"
624        echoAndLog "${FUNCNAME}(): checking if $database exists..."
625        echo "show databases" | mysql --defaults-extra-file=$TMPMYCNF | grep "^${database}$"
626        if [ $? -ne 0 ]; then
627                echoAndLog "${FUNCNAME}():database $database doesn't exists"
628                return 1
629        else
630                echoAndLog "${FUNCNAME}():database $database exists"
631                return 0
632        fi
633}
634
635# Comprueba si la base de datos está vacía.
636function mysqlCheckDbIsEmpty()
637{
638        if [ $# -ne 1 ]; then
639                errorAndLog "${FUNCNAME}(): invalid number of parameters"
640                exit 1
641        fi
642
643        local database="$1"
644        echoAndLog "${FUNCNAME}(): checking if $database is empty..."
645        num_tablas=`echo "show tables" | mysql --defaults-extra-file=$TMPMYCNF "${database}" | wc -l`
646        if [ $? -ne 0 ]; then
647                errorAndLog "${FUNCNAME}(): error executing query, check database and root password"
648                exit 1
649        fi
650
651        if [ $num_tablas -eq 0 ]; then
652                echoAndLog "${FUNCNAME}():database $database is empty"
653                return 0
654        else
655                echoAndLog "${FUNCNAME}():database $database has tables"
656                return 1
657        fi
658
659}
660
661# Importa un fichero SQL en la base de datos.
662# Parámetros:
663# - 1: nombre de la BD.
664# - 2: fichero a importar.
665# Nota: el fichero SQL puede contener las siguientes palabras reservadas:
666# - SERVERIP: se sustituye por la dirección IP del servidor.
667# - DBUSER: se sustituye por usuario de conexión a la BD definido en este script.
668# - DBPASSWD: se sustituye por la clave de conexión a la BD definida en este script.
669function mysqlImportSqlFileToDb()
670{
671        if [ $# -ne 2 ]; then
672                errorAndLog "${FNCNAME}(): invalid number of parameters"
673                exit 1
674        fi
675
676        local database="$1"
677        local sqlfile="$2"
678        local tmpfile=$(mktemp)
679        local i=0
680        local dev=""
681        local status
682        # Claves aleatorias para acceso a las APIs REST.
683        local OPENGNSYS_APIKEY=$(php -r 'echo md5(uniqid(rand(), true));')
684        OPENGNSYS_REPOKEY=$(php -r 'echo md5(uniqid(rand(), true));')
685
686        if [ ! -f $sqlfile ]; then
687                errorAndLog "${FUNCNAME}(): Unable to locate $sqlfile!!"
688                return 1
689        fi
690
691        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
692        chmod 600 $tmpfile
693        for dev in ${DEVICE[*]}; do
694                if [ "${DEVICE[i]}" == "$DEFAULTDEV" ]; then
695                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
696                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
697                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
698                            -e "s/APIKEY/$OPENGNSYS_APIKEY/g" \
699                            -e "s/REPOKEY/$OPENGNSYS_REPOKEY/g" \
700                                $sqlfile > $tmpfile
701                fi
702                let i++
703        done
704        mysql --defaults-extra-file=$TMPMYCNF --default-character-set=utf8 "${database}" < $tmpfile
705        status=$?
706        rm -f $tmpfile
707        if [ $status -ne 0 ]; then
708                errorAndLog "${FUNCNAME}(): error while importing $sqlfile in database $database"
709                return 1
710        fi
711        echoAndLog "${FUNCNAME}(): file imported to database $database"
712        return 0
713}
714
715# Crea la base de datos
716function mysqlCreateDb()
717{
718        if [ $# -ne 1 ]; then
719                errorAndLog "${FUNCNAME}(): invalid number of parameters"
720                exit 1
721        fi
722
723        local database="$1"
724
725        echoAndLog "${FUNCNAME}(): creating database..."
726        mysqladmin --defaults-extra-file=$TMPMYCNF create $database
727        if [ $? -ne 0 ]; then
728                errorAndLog "${FUNCNAME}(): error while creating database $database"
729                return 1
730        fi
731        # Quitar modo ONLY_FULL_GROUP_BY de MySQL (ticket #730).
732        mysql --defaults-extra-file=$TMPMYCNF -e "SET GLOBAL sql_mode=(SELECT TRIM(BOTH ',' FROM REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')));"
733
734        echoAndLog "${FUNCNAME}(): database $database created"
735        return 0
736}
737
738# Comprueba si ya está definido el usuario de acceso a la BD.
739function mysqlCheckUserExists()
740{
741        if [ $# -ne 1 ]; then
742                errorAndLog "${FUNCNAME}(): invalid number of parameters"
743                exit 1
744        fi
745
746        local userdb="$1"
747
748        echoAndLog "${FUNCNAME}(): checking if $userdb exists..."
749        echo "select user from user where user='${userdb}'\\G" |mysql --defaults-extra-file=$TMPMYCNF mysql | grep user
750        if [ $? -ne 0 ]; then
751                echoAndLog "${FUNCNAME}(): user doesn't exists"
752                return 1
753        else
754                echoAndLog "${FUNCNAME}(): user already exists"
755                return 0
756        fi
757
758}
759
760# Crea un usuario administrativo para la base de datos
761function mysqlCreateAdminUserToDb()
762{
763        if [ $# -ne 3 ]; then
764                errorAndLog "${FUNCNAME}(): invalid number of parameters"
765                exit 1
766        fi
767
768        local database="$1"
769        local userdb="$2"
770        local passdb="$3"
771
772        echoAndLog "${FUNCNAME}(): creating admin user ${userdb} to database ${database}"
773
774        cat > $WORKDIR/create_${database}.sql <<EOF
775GRANT USAGE ON *.* TO '${userdb}'@'localhost' IDENTIFIED BY '${passdb}' ;
776GRANT ALL PRIVILEGES ON ${database}.* TO '${userdb}'@'localhost' WITH GRANT OPTION ;
777FLUSH PRIVILEGES ;
778EOF
779        mysql --defaults-extra-file=$TMPMYCNF < $WORKDIR/create_${database}.sql
780        if [ $? -ne 0 ]; then
781                errorAndLog "${FUNCNAME}(): error while creating user in mysql"
782                rm -f $WORKDIR/create_${database}.sql
783                return 1
784        else
785                echoAndLog "${FUNCNAME}(): user created ok"
786                rm -f $WORKDIR/create_${database}.sql
787                return 0
788        fi
789}
790
791
792#####################################################################
793####### Funciones para la descarga de código
794#####################################################################
795
796# Obtiene el código fuente del proyecto desde el repositorio de GitHub.
797function downloadCode()
798{
799        if [ $# -ne 1 ]; then
800                errorAndLog "${FUNCNAME}(): invalid number of parameters"
801                exit 1
802        fi
803
804        local url="$1"
805
806        echoAndLog "${FUNCNAME}(): downloading code..."
807
808        curl "${url}" -o opengnsys.zip && unzip opengnsys.zip && mv "OpenGnsys-$BRANCH" opengnsys
809        if [ $? -ne 0 ]; then
810                errorAndLog "${FUNCNAME}(): error getting OpenGnsys code from $url"
811                return 1
812        fi
813        rm -f opengnsys.zip
814        echoAndLog "${FUNCNAME}(): code was downloaded"
815        return 0
816}
817
818
819############################################################
820###  Detectar red
821############################################################
822
823# Comprobar si existe conexión.
824function checkNetworkConnection()
825{
826        echoAndLog "${FUNCNAME}(): Disabling Firewall: $FIREWALLSERV."
827        if [ -n "$FIREWALLSERV" ]; then
828                service=$FIREWALLSERV
829                $STOPSERVICE; $DISABLESERVICE
830        fi
831
832        echoAndLog "${FUNCNAME}(): Checking OpenGnsys server conectivity."
833        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"opengnsys.es"}
834        if which wget &>/dev/null; then
835                wget --spider -q $OPENGNSYS_SERVER
836        elif which curl &>/dev/null; then
837                curl --connect-timeout 10 -s $OPENGNSYS_SERVER -o /dev/null
838        else
839                echoAndLog "${FUNCNAME}(): Cannot execute \"wget\" nor \"curl\"."
840                return 1
841        fi
842}
843
844# Convierte nº de bits (notación CIDR) en máscara de red (gracias a FriedZombie en openwrt.org).
845cidr2mask ()
846{
847        # Number of args to shift, 255..255, first non-255 byte, zeroes
848        set -- $[ 5 - ($1 / 8) ] 255 255 255 255 $[ (255 << (8 - ($1 % 8))) & 255 ] 0 0 0
849        [ $1 -gt 1 ] && shift $1 || shift
850        echo ${1-0}.${2-0}.${3-0}.${4-0}
851}
852
853# Obtener los parámetros de red de la interfaz por defecto.
854function getNetworkSettings()
855{
856        # Arrays globales definidas:
857        # - DEVICE:     nombres de dispositivos de red activos.
858        # - SERVERIP:   IPs locales del servidor.
859        # - NETIP:      IPs de redes.
860        # - NETMASK:    máscaras de red.
861        # - NETBROAD:   IPs de difusión de redes.
862        # - ROUTERIP:   IPs de routers.
863        # Otras variables globales:
864        # - DEFAULTDEV: dispositivo de red por defecto.
865        # - DNSIP:      IP del servidor DNS principal.
866
867        local i=0
868        local dev=""
869
870        echoAndLog "${FUNCNAME}(): Detecting network parameters."
871        DEVICE=( $(ip -o link show up | awk '!/loopback/ {sub(/:.*/,"",$2); print $2}') )
872        if [ -z "$DEVICE" ]; then
873                errorAndLog "${FUNCNAME}(): Network devices not detected."
874                exit 1
875        fi
876        for dev in ${DEVICE[*]}; do
877                SERVERIP[i]=$(ip -o addr show dev "$dev" | awk '$3~/inet$/ {sub (/\/.*/, ""); print ($4)}')
878                if [ -n "${SERVERIP[i]}" ]; then
879                        NETMASK[i]=$( cidr2mask $(ip -o addr show dev "$dev" | awk '$3~/inet$/ {sub (/.*\//, "", $4); print ($4)}') )
880                        NETBROAD[i]=$(ip -o addr show dev "$dev" | awk '$3~/inet$/ {print ($6)}')
881                        NETIP[i]=$(ip route list proto kernel | awk -v d="$dev" '$3==d && /src/ {sub (/\/.*/,""); print $1}')
882                        ROUTERIP[i]=$(ip route list default | awk -v d="$dev" '$5==d {print $3}')
883                        DEFAULTDEV=${DEFAULTDEV:-"$dev"}
884                fi
885                let i++
886        done
887        DNSIP=$(awk '/nameserver/ {print $2}' /etc/resolv.conf | head -n1)
888        if [ -z "${NETIP[*]}" -o -z "${NETMASK[*]}" ]; then
889                errorAndLog "${FUNCNAME}(): Network not detected."
890                exit 1
891        fi
892
893        # Variables de ejecución de Apache
894        # - APACHE_RUN_USER
895        # - APACHE_RUN_GROUP
896        if [ -f $APACHECFGDIR/envvars ]; then
897                source $APACHECFGDIR/envvars
898        fi
899        APACHE_RUN_USER=${APACHE_RUN_USER:-"$APACHEUSER"}
900        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"$APACHEGROUP"}
901
902        echoAndLog "${FUNCNAME}(): Default network device: $DEFAULTDEV."
903}
904
905
906############################################################
907### Esqueleto para el Servicio pxe y contenedor tftpboot ###
908############################################################
909
910function tftpConfigure()
911{
912        echoAndLog "${FUNCNAME}(): Configuring TFTP service."
913        # Habilitar TFTP y reiniciar Inetd.
914        if [ -n "$TFTPSERV" ]; then
915                if [ -f $INETDCFGDIR/$TFTPSERV ]; then
916                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/$TFTPSERV
917                else
918                        service=$TFTPSERV
919                        $ENABLESERVICE; $STARTSERVICE
920                fi
921        fi
922        service=$INETDSERV
923        $ENABLESERVICE; $STARTSERVICE
924
925        # comprobamos el servicio tftp
926        sleep 1
927        testPxe
928}
929
930# Comprueba que haya conexión al servicio TFTP/PXE.
931function testPxe ()
932{
933        echoAndLog "${FUNCNAME}(): Checking TFTP service... please wait."
934        echo "test" >$TFTPCFGDIR/testpxe
935        tftp -v 127.0.0.1 -c get testpxe /tmp/testpxe && echoAndLog "TFTP service is OK." || errorAndLog "TFTP service is down."
936        rm -f $TFTPCFGDIR/testpxe /tmp/testpxe
937}
938
939
940########################################################################
941## Configuración servicio Samba
942########################################################################
943
944# Configurar servicios Samba.
945function smbConfigure()
946{
947        echoAndLog "${FUNCNAME}(): Configuring Samba service."
948
949        backupFile $SAMBACFGDIR/smb.conf
950       
951        # Copiar plantailla de recursos para OpenGnsys
952        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
953                $WORKDIR/opengnsys/server/etc/smb-og.conf.tmpl > $SAMBACFGDIR/smb-og.conf
954        # Configurar y recargar Samba"
955        perl -pi -e "s/WORKGROUP/OPENGNSYS/; s/server string \=.*/server string \= OpenGnsys Samba Server/" $SAMBACFGDIR/smb.conf
956        if ! grep -q "smb-og" $SAMBACFGDIR/smb.conf; then
957                echo "include = $SAMBACFGDIR/smb-og.conf" >> $SAMBACFGDIR/smb.conf
958        fi
959        service=$SAMBASERV
960        $ENABLESERVICE; $STARTSERVICE
961        if [ $? -ne 0 ]; then
962                errorAndLog "${FUNCNAME}(): error while configure Samba"
963                return 1
964        fi
965        # Crear clave para usuario de acceso a los recursos.
966        echo -ne "$OPENGNSYS_CLIENT_PASSWD\n$OPENGNSYS_CLIENT_PASSWD\n" | smbpasswd -a -s $OPENGNSYS_CLIENT_USER
967
968        echoAndLog "${FUNCNAME}(): Added Samba configuration."
969        return 0
970}
971
972
973########################################################################
974## Configuración servicio Rsync
975########################################################################
976
977# Configurar servicio Rsync.
978function rsyncConfigure()
979{
980        echoAndLog "${FUNCNAME}(): Configuring Rsync service."
981
982        backupFile $RSYNCCFGDIR/rsyncd.conf
983
984        # Configurar acceso a Rsync.
985        sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENT_USER/g" \
986                $WORKDIR/opengnsys/repoman/etc/rsyncd.conf.tmpl > $RSYNCCFGDIR/rsyncd.conf
987        sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENT_USER/g" \
988            -e "s/CLIENTPASSWORD/$OPENGNSYS_CLIENT_PASSWD/g" \
989                $WORKDIR/opengnsys/repoman/etc/rsyncd.secrets.tmpl > $RSYNCCFGDIR/rsyncd.secrets
990        chown root.root $RSYNCCFGDIR/rsyncd.secrets
991        chmod 600 $RSYNCCFGDIR/rsyncd.secrets
992
993        # Habilitar Rsync y reiniciar Inetd.
994        if [ -n "$RSYNCSERV" ]; then
995                if [ -f /etc/default/rsync ]; then
996                        perl -pi -e 's/RSYNC_ENABLE=.*/RSYNC_ENABLE=inetd/' /etc/default/rsync
997                fi
998                if [ -f $INETDCFGDIR/rsync ]; then
999                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/rsync
1000                else
1001                        cat << EOT > $INETDCFGDIR/rsync
1002service rsync
1003{
1004        disable = no
1005        socket_type = stream
1006        wait = no
1007        user = root
1008        server = $(which rsync)
1009        server_args = --daemon
1010        log_on_failure += USERID
1011        flags = IPv6
1012}
1013EOT
1014                fi
1015                service=$RSYNCSERV $ENABLESERVICE
1016                service=$INETDSERV $STARTSERVICE
1017        fi
1018
1019        echoAndLog "${FUNCNAME}(): Added Rsync configuration."
1020        return 0
1021}
1022
1023       
1024########################################################################
1025## Configuración servicio DHCP
1026########################################################################
1027
1028# Configurar servicios DHCP.
1029function dhcpConfigure()
1030{
1031        echoAndLog "${FUNCNAME}(): Sample DHCP configuration."
1032
1033        local errcode=0
1034        local i=0
1035        local dev=""
1036
1037        backupFile $DHCPCFGDIR/dhcpd.conf
1038        for dev in ${DEVICE[*]}; do
1039                if [ -n "${SERVERIP[i]}" ]; then
1040                        backupFile $DHCPCFGDIR/dhcpd-$dev.conf
1041                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1042                            -e "s/NETIP/${NETIP[i]}/g" \
1043                            -e "s/NETMASK/${NETMASK[i]}/g" \
1044                            -e "s/NETBROAD/${NETBROAD[i]}/g" \
1045                            -e "s/ROUTERIP/${ROUTERIP[i]}/g" \
1046                            -e "s/DNSIP/$DNSIP/g" \
1047                            $WORKDIR/opengnsys/server/etc/dhcpd.conf.tmpl > $DHCPCFGDIR/dhcpd-$dev.conf || errcode=1
1048                fi
1049                let i++
1050        done
1051        if [ $errcode -ne 0 ]; then
1052                errorAndLog "${FUNCNAME}(): error while configuring DHCP server"
1053                return 1
1054        fi
1055        ln -f $DHCPCFGDIR/dhcpd-$DEFAULTDEV.conf $DHCPCFGDIR/dhcpd.conf
1056        service=$DHCPSERV
1057        $ENABLESERVICE; $STARTSERVICE
1058        echoAndLog "${FUNCNAME}(): Sample DHCP configured in \"$DHCPCFGDIR\"."
1059        return 0
1060}
1061
1062
1063#####################################################################
1064####### Funciones específicas de la instalación de Opengnsys
1065#####################################################################
1066
1067# Copiar ficheros del OpenGnsys Web Console.
1068function installWebFiles()
1069{
1070        local COMPATDIR f
1071        local SLIMFILE="slim-2.6.1.zip"
1072        local SWAGGERFILE="swagger-ui-2.2.5.zip"
1073
1074        echoAndLog "${FUNCNAME}(): Installing web files..."
1075        # Copiar ficheros.
1076        cp -a $WORKDIR/opengnsys/admin/WebConsole/* $INSTALL_TARGET/www   #*/ comentario para Doxygen.
1077        if [ $? != 0 ]; then
1078                errorAndLog "${FUNCNAME}(): Error copying web files."
1079                exit 1
1080        fi
1081
1082        # Descomprimir librerías: Slim y Swagger-UI.
1083        unzip -o $WORKDIR/opengnsys/admin/$SLIMFILE -d $INSTALL_TARGET/www/rest
1084        unzip -o $WORKDIR/opengnsys/admin/$SWAGGERFILE -d $INSTALL_TARGET/www/rest
1085
1086        # Compatibilidad con dispositivos móviles.
1087        COMPATDIR="$INSTALL_TARGET/www/principal"
1088        for f in acciones administracion aula aulas hardwares imagenes menus repositorios softwares; do
1089                sed 's/clickcontextualnodo/clicksupnodo/g' $COMPATDIR/$f.php > $COMPATDIR/$f.device.php
1090        done
1091        cp -a $COMPATDIR/imagenes.device.php $COMPATDIR/imagenes.device4.php
1092        # Cambiar permisos para ficheros especiales.
1093        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/images/{fotos,iconos}
1094        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/tmp/
1095        # Ficheros de log de la API REST.
1096        touch $INSTALL_TARGET/log/{ogagent,remotepc,rest}.log
1097        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/log/{ogagent,remotepc,rest}.log
1098
1099        echoAndLog "${FUNCNAME}(): Web files installed successfully."
1100}
1101
1102# Copiar ficheros en la zona de descargas de OpenGnsys Web Console.
1103function installDownloadableFiles()
1104{
1105        INSTVERSION=1.1.0       ###  Temporal.
1106        local FILENAME=ogagentpkgs-$INSTVERSION.tar.gz
1107        local TARGETFILE=$WORKDIR/$FILENAME
1108 
1109        # Descargar archivo comprimido, si es necesario.
1110        if [ -s $PROGRAMDIR/$FILENAME ]; then
1111                echoAndLog "${FUNCNAME}(): Moving $PROGRAMDIR/$FILENAME file to $(dirname $TARGETFILE)"
1112                mv $PROGRAMDIR/$FILENAME $TARGETFILE
1113        else
1114                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
1115                curl $DOWNLOADURL/$FILENAME -o $TARGETFILE
1116        fi
1117        if [ ! -s $TARGETFILE ]; then
1118                errorAndLog "${FUNCNAME}(): Cannot download $FILENAME"
1119                return 1
1120        fi
1121       
1122        # Descomprimir fichero en zona de descargas.
1123        tar xvzf $TARGETFILE -C $INSTALL_TARGET/www/descargas
1124        if [ $? != 0 ]; then
1125                errorAndLog "${FUNCNAME}(): Error uncompressing archive."
1126                exit 1
1127        fi
1128}
1129
1130# Configuración específica de Apache.
1131function installWebConsoleApacheConf()
1132{
1133        if [ $# -ne 2 ]; then
1134                errorAndLog "${FUNCNAME}(): invalid number of parameters"
1135                exit 1
1136        fi
1137
1138        local path_opengnsys_base="$1"
1139        local path_apache2_confd="$2"
1140        local CONSOLEDIR=${path_opengnsys_base}/www
1141
1142        if [ ! -d $path_apache2_confd ]; then
1143                errorAndLog "${FUNCNAME}(): path to apache2 conf.d can not found, verify your server installation"
1144                return 1
1145        fi
1146
1147        mkdir -p $path_apache2_confd/{sites-available,sites-enabled}
1148
1149        echoAndLog "${FUNCNAME}(): creating apache2 config file.."
1150
1151        # Activar HTTPS.
1152        $APACHESSLMOD
1153        $APACHEENABLESSL
1154        $APACHEMAKECERT
1155        # Activar módulo Rewrite.
1156        $APACHEREWRITEMOD
1157        # Genera configuración de consola web a partir del fichero plantilla.
1158        if [ -n "$(apachectl -v | grep "2\.[0-2]")" ]; then
1159                # Configuración para versiones anteriores de Apache.
1160                sed -e "s,CONSOLEDIR,$CONSOLEDIR,g" \
1161                        $WORKDIR/opengnsys/server/etc/apache-prev2.4.conf.tmpl > $path_apache2_confd/$APACHESITESDIR/${APACHEOGSITE}
1162        else
1163                # Configuración específica a partir de Apache 2.4
1164                sed -e "s,CONSOLEDIR,$CONSOLEDIR,g" \
1165                        $WORKDIR/opengnsys/server/etc/apache.conf.tmpl > $path_apache2_confd/$APACHESITESDIR/${APACHEOGSITE}.conf
1166        fi
1167        $APACHEENABLEOG
1168        if [ $? -ne 0 ]; then
1169                errorAndLog "${FUNCNAME}(): config file can't be linked to apache conf, verify your server installation"
1170                return 1
1171        fi
1172        echoAndLog "${FUNCNAME}(): config file created and linked, restarting apache daemon"
1173        service=$APACHESERV
1174        $ENABLESERVICE; $STARTSERVICE
1175        return 0
1176}
1177
1178
1179# Crear documentación Doxygen para la consola web.
1180function makeDoxygenFiles()
1181{
1182        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
1183        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
1184                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
1185        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
1186                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
1187                return 1
1188        fi
1189        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
1190        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/api
1191        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
1192}
1193
1194
1195# Crea la estructura base de la instalación de opengnsys
1196function createDirs()
1197{
1198        if [ $# -ne 1 ]; then
1199                errorAndLog "${FUNCNAME}(): invalid number of parameters"
1200                exit 1
1201        fi
1202
1203        local path_opengnsys_base="$1"
1204
1205        # Crear estructura de directorios.
1206        echoAndLog "${FUNCNAME}(): creating directory paths in $path_opengnsys_base"
1207        mkdir -p $path_opengnsys_base
1208        mkdir -p $path_opengnsys_base/bin
1209        mkdir -p $path_opengnsys_base/client/{cache,images,log}
1210        mkdir -p $path_opengnsys_base/doc
1211        mkdir -p $path_opengnsys_base/etc
1212        mkdir -p $path_opengnsys_base/lib
1213        mkdir -p $path_opengnsys_base/log/clients
1214        ln -fs $path_opengnsys_base/log /var/log/opengnsys
1215        mkdir -p $path_opengnsys_base/sbin
1216        mkdir -p $path_opengnsys_base/www
1217        mkdir -p $path_opengnsys_base/images/groups
1218        mkdir -p $TFTPCFGDIR
1219        ln -fs $TFTPCFGDIR $path_opengnsys_base/tftpboot
1220        mkdir -p $path_opengnsys_base/tftpboot/{menu.lst,grub}
1221        if [ $? -ne 0 ]; then
1222                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
1223                return 1
1224        fi
1225
1226        # Crear usuario ficticio.
1227        if id -u $OPENGNSYS_CLIENT_USER &>/dev/null; then
1228                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENT_USER\" is already created"
1229        else
1230                echoAndLog "${FUNCNAME}(): creating OpenGnsys user"
1231                useradd $OPENGNSYS_CLIENT_USER 2>/dev/null
1232                if [ $? -ne 0 ]; then
1233                        errorAndLog "${FUNCNAME}(): error creating OpenGnsys user"
1234                        return 1
1235                fi
1236        fi
1237
1238        # Establecer los permisos básicos.
1239        echoAndLog "${FUNCNAME}(): setting directory permissions"
1240        chmod -R 775 $path_opengnsys_base/{log/clients,images}
1241        chown -R :$OPENGNSYS_CLIENT_USER $path_opengnsys_base/{log/clients,images}
1242        if [ $? -ne 0 ]; then
1243                errorAndLog "${FUNCNAME}(): error while setting permissions"
1244                return 1
1245        fi
1246
1247        # Mover el fichero de registro de instalación al directorio de logs.
1248        echoAndLog "${FUNCNAME}(): moving installation log file"
1249        mv $LOG_FILE $OGLOGFILE && LOG_FILE=$OGLOGFILE
1250        chmod 600 $LOG_FILE
1251
1252        echoAndLog "${FUNCNAME}(): directory paths created"
1253        return 0
1254}
1255
1256# Copia ficheros de configuración y ejecutables genéricos del servidor.
1257function copyServerFiles ()
1258{
1259        if [ $# -ne 1 ]; then
1260                errorAndLog "${FUNCNAME}(): invalid number of parameters"
1261                exit 1
1262        fi
1263
1264        local path_opengnsys_base="$1"
1265
1266        # Lista de ficheros y directorios origen y de directorios destino.
1267        local SOURCES=( server/tftpboot \
1268                        /usr/lib/shim/shimx64.efi.signed \
1269                        /usr/lib/grub/x86_64-efi-signed/grubnetx64.efi.signed \
1270                        server/bin \
1271                        repoman/bin \
1272                        server/lib \
1273                        admin/Sources/Services/ogAdmServerAux
1274                        admin/Sources/Services/ogAdmRepoAux
1275                        installer/opengnsys_uninstall.sh \
1276                        installer/opengnsys_update.sh \
1277                        installer/opengnsys_export.sh \
1278                        installer/opengnsys_import.sh \
1279                        doc )
1280        local TARGETS=( tftpboot \
1281                        tftpboot \
1282                        tftpboot/grubx64.efi \
1283                        bin \
1284                        bin \
1285                        lib \
1286                        sbin \
1287                        sbin \
1288                        lib \
1289                        lib \
1290                        lib \
1291                        lib \
1292                        doc )
1293
1294        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
1295                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
1296                exit 1
1297        fi
1298
1299        # Copiar ficheros.
1300        echoAndLog "${FUNCNAME}(): copying files to server directories"
1301
1302        pushd $WORKDIR/opengnsys
1303        local i
1304        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
1305                if [ -f "${SOURCES[$i]}" ]; then
1306                        echoAndLog "Copying ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
1307                        cp -a "${SOURCES[$i]}" "${path_opengnsys_base}/${TARGETS[$i]}"
1308                elif [ -d "${SOURCES[$i]}" ]; then
1309                        echoAndLog "Copying content of ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
1310                        cp -a "${SOURCES[$i]}"/* "${path_opengnsys_base}/${TARGETS[$i]}"
1311                else
1312                        warningAndLog "Unable to copy ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
1313                fi
1314        done
1315
1316        popd
1317}
1318
1319####################################################################
1320### Funciones de compilación de código fuente de servicios
1321####################################################################
1322
1323# Compilar los servicios de OpenGnsys
1324function servicesCompilation ()
1325{
1326        local hayErrores=0
1327
1328        # Compilar OpenGnsys Server
1329        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Admin Server"
1330        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
1331        make && mv ogAdmServer $INSTALL_TARGET/sbin
1332        if [ $? -ne 0 ]; then
1333                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Server"
1334                hayErrores=1
1335        fi
1336        popd
1337        # Compilar OpenGnsys Repository Manager
1338        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Repository Manager"
1339        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo
1340        make && mv ogAdmRepo $INSTALL_TARGET/sbin
1341        if [ $? -ne 0 ]; then
1342                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Repository Manager"
1343                hayErrores=1
1344        fi
1345        popd
1346        # Compilar OpenGnsys Agent
1347        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Agent"
1348        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
1349        make && mv ogAdmAgent $INSTALL_TARGET/sbin
1350        if [ $? -ne 0 ]; then
1351                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Agent"
1352                hayErrores=1
1353        fi
1354        popd   
1355        # Compilar OpenGnsys Client
1356        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Admin Client"
1357        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
1358        make && mv ogAdmClient ../../../../client/shared/bin
1359        if [ $? -ne 0 ]; then
1360                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Client"
1361                hayErrores=1
1362        fi
1363        popd
1364
1365        return $hayErrores
1366}
1367
1368####################################################################
1369### Funciones de copia de la Interface de administración
1370####################################################################
1371
1372# Copiar carpeta de Interface
1373function copyInterfaceAdm ()
1374{
1375        local hayErrores=0
1376       
1377        # Crear carpeta y copiar Interface
1378        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
1379        cp -ar $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client/interfaceAdm
1380        if [ $? -ne 0 ]; then
1381                echoAndLog "${FUNCNAME}(): error while copying Administration Interface Folder"
1382                hayErrores=1
1383        fi
1384        chown $OPENGNSYS_CLIENT_USER:$OPENGNSYS_CLIENT_USER $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
1385        chmod 700 $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
1386
1387        return $hayErrores
1388}
1389
1390####################################################################
1391### Funciones instalacion cliente opengnsys
1392####################################################################
1393
1394function copyClientFiles()
1395{
1396        local errstatus=0
1397
1398        echoAndLog "${FUNCNAME}(): Copying OpenGnsys Client files."
1399        cp -a $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
1400        if [ $? -ne 0 ]; then
1401                errorAndLog "${FUNCNAME}(): error while copying client estructure"
1402                errstatus=1
1403        fi
1404       
1405        echoAndLog "${FUNCNAME}(): Copying OpenGnsys Cloning Engine files."
1406        mkdir -p $INSTALL_TARGET/client/lib/engine/bin
1407        cp -a $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
1408        if [ $? -ne 0 ]; then
1409                errorAndLog "${FUNCNAME}(): error while copying engine files"
1410                errstatus=1
1411        fi
1412       
1413        if [ $errstatus -eq 0 ]; then
1414                echoAndLog "${FUNCNAME}(): client copy files success."
1415        else
1416                errorAndLog "${FUNCNAME}(): client copy files with errors"
1417        fi
1418
1419        return $errstatus
1420}
1421
1422
1423# Crear cliente OpenGnsys.
1424function clientCreate()
1425{
1426        if [ $# -ne 1 ]; then
1427                errorAndLog "${FUNCNAME}(): invalid number of parameters"
1428                exit 1
1429        fi
1430
1431        local FILENAME="$1"
1432        local TARGETFILE=$INSTALL_TARGET/lib/$FILENAME
1433 
1434        # Descargar cliente, si es necesario.
1435        if [ -s $PROGRAMDIR/$FILENAME ]; then
1436                echoAndLog "${FUNCNAME}(): Moving $PROGRAMDIR/$FILENAME file to $(dirname $TARGETFILE)"
1437                mv $PROGRAMDIR/$FILENAME $TARGETFILE
1438        else
1439                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
1440                oglivecli download $FILENAME
1441        fi
1442        if [ ! -s $TARGETFILE ]; then
1443                errorAndLog "${FUNCNAME}(): Error loading $FILENAME"
1444                return 1
1445        fi
1446
1447        # Montar imagen, copiar cliente ogclient y desmontar.
1448        echoAndLog "${FUNCNAME}(): Installing ogLive Client"
1449        echo -ne "$OPENGNSYS_CLIENT_PASSWD\n$OPENGNSYS_CLIENT_PASSWD\n" | \
1450                        oglivecli install $FILENAME
1451        # Adaptar permisos.
1452        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/tftpboot/menu.lst
1453
1454        echoAndLog "${FUNCNAME}(): Client generation success"
1455}
1456
1457
1458# Configuración básica de servicios de OpenGnsys
1459function openGnsysConfigure()
1460{
1461        local i=0
1462        local dev=""
1463        local CONSOLEURL
1464
1465        echoAndLog "${FUNCNAME}(): Copying init files."
1466        cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
1467        cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.default /etc/default/opengnsys
1468        # Deshabilitar servicios de BitTorrent si no están instalados.
1469        if [ ! -e /usr/bin/bttrack ]; then
1470                sed -i 's/RUN_BTTRACKER="yes"/RUN_BTTRACKER="no"/; s/RUN_BTSEEDER="yes"/RUN_BTSEEDER="no"/' \
1471                        /etc/default/opengnsys
1472        fi
1473        echoAndLog "${FUNCNAME}(): Creating cron files."
1474        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/opengnsys.cron ] && $INSTALL_TARGET/bin/opengnsys.cron" > /etc/cron.d/opengnsys
1475        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
1476        echo "5 * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-tracker ] && $INSTALL_TARGET/bin/torrent-tracker" > /etc/cron.d/torrenttracker
1477        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/deletepreimage ] && $INSTALL_TARGET/bin/deletepreimage" > /etc/cron.d/imagedelete
1478        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/ogagentqueue.cron ] && $INSTALL_TARGET/bin/ogagentqueue.cron" > /etc/cron.d/ogagentqueue
1479
1480        echoAndLog "${FUNCNAME}(): Creating logrotate configuration file."
1481        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
1482                $WORKDIR/opengnsys/server/etc/logrotate.tmpl > /etc/logrotate.d/opengnsys
1483
1484        echoAndLog "${FUNCNAME}(): Creating OpenGnsys config files."
1485        for dev in ${DEVICE[*]}; do
1486                if [ -n "${SERVERIP[i]}" ]; then
1487                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1488                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1489                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1490                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
1491                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer/ogAdmServer.cfg > $INSTALL_TARGET/etc/ogAdmServer-$dev.cfg
1492                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1493                            -e "s/REPOKEY/$OPENGNSYS_REPOKEY/g" \
1494                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo/ogAdmRepo.cfg > $INSTALL_TARGET/etc/ogAdmRepo-$dev.cfg
1495                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1496                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1497                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1498                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
1499                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent/ogAdmAgent.cfg > $INSTALL_TARGET/etc/ogAdmAgent-$dev.cfg
1500                        CONSOLEURL="https://${SERVERIP[i]}/opengnsys"
1501                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1502                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1503                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1504                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
1505                            -e "s/OPENGNSYSURL/${CONSOLEURL//\//\\/}/g" \
1506                                $INSTALL_TARGET/www/controlacceso.php > $INSTALL_TARGET/www/controlacceso-$dev.php
1507                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1508                            -e "s/OPENGNSYSURL/${CONSOLEURL//\//\\/}/g" \
1509                                $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient/ogAdmClient.cfg > $INSTALL_TARGET/client/etc/ogAdmClient-$dev.cfg
1510                        if [ "$dev" == "$DEFAULTDEV" ]; then
1511                                OPENGNSYS_CONSOLEURL="$CONSOLEURL"
1512                        fi
1513                fi
1514                let i++
1515        done
1516        ln -f $INSTALL_TARGET/etc/ogAdmServer-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmServer.cfg
1517        ln -f $INSTALL_TARGET/etc/ogAdmRepo-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmRepo.cfg
1518        ln -f $INSTALL_TARGET/etc/ogAdmAgent-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmAgent.cfg
1519        ln -f $INSTALL_TARGET/client/etc/ogAdmClient-$DEFAULTDEV.cfg $INSTALL_TARGET/client/etc/ogAdmClient.cfg
1520        ln -f $INSTALL_TARGET/www/controlacceso-$DEFAULTDEV.php $INSTALL_TARGET/www/controlacceso.php
1521        chown root:root $INSTALL_TARGET/etc/{ogAdmServer,ogAdmAgent}*.cfg
1522        chmod 600 $INSTALL_TARGET/etc/{ogAdmServer,ogAdmAgent}*.cfg
1523        chown $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/controlacceso*.php
1524        chmod 600 $INSTALL_TARGET/www/controlacceso*.php
1525
1526        # Configuración del motor de clonación.
1527        # - Zona horaria del servidor.
1528        TZ=$(timedatectl status|awk -F"[:()]" '/Time.*zone/ {print $2}')
1529        cat << EOT >> $INSTALL_TARGET/client/etc/engine.cfg
1530# OpenGnsys Server timezone.
1531TZ="${TZ// /}"
1532EOT
1533
1534        # Revisar permisos generales.
1535        if [ -x $INSTALL_TARGET/bin/checkperms ]; then
1536                echoAndLog "${FUNCNAME}(): Checking permissions."
1537                OPENGNSYS_DIR="$INSTALL_TARGET" OPENGNSYS_USER="$OPENGNSYS_CLIENT_USER" APACHE_USER="$APACHE_RUN_USER" APACHE_GROUP="$APACHE_RUN_GROUP" checkperms
1538        fi
1539
1540        # Evitar inicio de duplicado en Ubuntu 14.04 (Upstart y SysV Init).
1541        if [ -f /etc/init/${MYSQLSERV}.conf -a -n "$(which initctl 2>/dev/null)" ]; then
1542                service=$MYSQLSERV
1543                $DISABLESERVICE
1544        fi
1545
1546        echoAndLog "${FUNCNAME}(): Starting OpenGnsys services."
1547        service="opengnsys"
1548        $ENABLESERVICE; $STARTSERVICE
1549}
1550
1551
1552#####################################################################
1553#######  Función de resumen informativo de la instalación
1554#####################################################################
1555
1556function installationSummary()
1557{
1558        local VERSIONFILE REVISION
1559
1560        # Crear fichero de versión y revisión, si no existe.
1561        VERSIONFILE="$INSTALL_TARGET/doc/VERSION.json"
1562        [ -f $VERSIONFILE ] || echo '{ "project": "OpenGnsys" }' >$VERSIONFILE
1563        # Incluir datos de revisión, si se está instalando desde el repositorio
1564        # de código o si no está incluida en el fichero de versión.
1565        if [ $REMOTE -eq 1 ] || [ -z "$(jq -r '.release' $VERSIONFILE)" ]; then
1566                # Revisión: rAñoMesDía.Gitcommit (8 caracteres de fecha y 7 primeros de commit).
1567                REVISION=$(curl -s "$API_URL" | jq '"r" + (.commit.commit.committer.date | gsub("-"; "")[:8]) + "." + (.commit.sha[:7])')
1568                jq ".release=$REVISION" $VERSIONFILE | sponge $VERSIONFILE
1569        fi
1570        VERSION="$(jq -r '[.project, .version, .codename, .release] | join(" ")' $VERSIONFILE 2>/dev/null)"
1571
1572        # Mostrar información.
1573        echo
1574        echoAndLog "OpenGnsys Installation Summary"
1575        echo       "=============================="
1576        echoAndLog "Project version:                  $VERSION"
1577        echoAndLog "Installation directory:           $INSTALL_TARGET"
1578        echoAndLog "Installation log file:            $LOG_FILE"
1579        echoAndLog "Repository directory:             $INSTALL_TARGET/images"
1580        echoAndLog "DHCP configuration directory:     $DHCPCFGDIR"
1581        echoAndLog "TFTP configuration directory:     $TFTPCFGDIR"
1582        echoAndLog "Installed ogLive client(s):       $(oglivecli list | awk '{print $2}')"
1583        echoAndLog "Samba configuration directory:    $SAMBACFGDIR"
1584        echoAndLog "Web Console URL:                  $OPENGNSYS_CONSOLEURL"
1585        echoAndLog "Web Console access data:          specified in installer script"
1586        if grep -q "^RUN_BTTRACK.*no" /etc/default/opengnsys; then
1587                echoAndLog "BitTorrent service is disabled."
1588        fi
1589        echo
1590        echoAndLog "Post-Installation Instructions:"
1591        echo       "==============================="
1592        echoAndLog "Firewall service has been disabled and SELinux mode set to"
1593        echoAndLog "   permissive during OpenGnsys installation. Please check"
1594        echoAndLog "   ${FIREWALLSERV:-firewall} and SELinux configuration, if needed."
1595        echoAndLog "It's strongly recommended to synchronize this server with an NTP server."
1596        echoAndLog "Review or edit all configuration files."
1597        echoAndLog "Insert DHCP configuration data and restart service."
1598        echoAndLog "Optional: Log-in as Web Console admin user."
1599        echoAndLog " - Review default Organization data and assign access to users."
1600        echoAndLog "Log-in as Web Console organization user."
1601        echoAndLog " - Insert OpenGnsys data (labs, computers, menus, etc)."
1602echo
1603}
1604
1605
1606
1607#####################################################################
1608####### Proceso de instalación de OpenGnsys
1609#####################################################################
1610
1611echoAndLog "OpenGnsys installation begins at $(date)"
1612pushd $WORKDIR
1613
1614# Detectar datos iniciales de auto-configuración del instalador.
1615autoConfigure
1616
1617# Detectar parámetros de red y comprobar si hay conexión.
1618getNetworkSettings
1619if [ $? -ne 0 ]; then
1620        errorAndLog "Error reading default network settings."
1621        exit 1
1622fi
1623checkNetworkConnection
1624if [ $? -ne 0 ]; then
1625        errorAndLog "Error connecting to server. Causes:"
1626        errorAndLog " - Network is unreachable, review devices parameters."
1627        errorAndLog " - You are inside a private network, configure the proxy service."
1628        errorAndLog " - Server is temporally down, try agian later."
1629        exit 1
1630fi
1631
1632# Detener servicios de OpenGnsys, si están activos previamente.
1633[ -f /etc/init.d/opengnsys ] && /etc/init.d/opengnsys stop
1634
1635# Actualizar repositorios
1636updatePackageList
1637
1638# Instalación de dependencias (paquetes de sistema operativo).
1639declare -a notinstalled
1640checkDependencies DEPENDENCIES notinstalled
1641if [ $? -ne 0 ]; then
1642        installDependencies notinstalled
1643        if [ $? -ne 0 ]; then
1644                echoAndLog "Error while installing some dependeces, please verify your server installation before continue"
1645                exit 1
1646        fi
1647fi
1648if [ -n "$INSTALLEXTRADEPS" ]; then
1649        echoAndLog "Installing extra dependencies"
1650        for (( i=0; i<${#INSTALLEXTRADEPS[*]}; i++ )); do
1651                eval ${INSTALLEXTRADEPS[i]}
1652        done
1653fi     
1654
1655# Detectar datos de auto-configuración después de instalar paquetes.
1656autoConfigurePost
1657
1658# Arbol de directorios de OpenGnsys.
1659createDirs ${INSTALL_TARGET}
1660if [ $? -ne 0 ]; then
1661        errorAndLog "Error while creating directory paths!"
1662        exit 1
1663fi
1664
1665# Si es necesario, descarga el repositorio de código en directorio temporal
1666if [ $REMOTE -eq 1 ]; then
1667        downloadCode $CODE_URL
1668        if [ $? -ne 0 ]; then
1669                errorAndLog "Error while getting code from the repository"
1670                exit 1
1671        fi
1672else
1673        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
1674fi
1675
1676# Compilar código fuente de los servicios de OpenGnsys.
1677servicesCompilation
1678if [ $? -ne 0 ]; then
1679        errorAndLog "Error while compiling OpenGnsys services"
1680        exit 1
1681fi
1682
1683# Copiar carpeta Interface entre administración y motor de clonación.
1684copyInterfaceAdm
1685if [ $? -ne 0 ]; then
1686        errorAndLog "Error while copying Administration Interface"
1687        exit 1
1688fi
1689
1690# Configuración de TFTP.
1691tftpConfigure
1692
1693# Configuración de Samba.
1694smbConfigure
1695if [ $? -ne 0 ]; then
1696        errorAndLog "Error while configuring Samba server!"
1697        exit 1
1698fi
1699
1700# Configuración de Rsync.
1701rsyncConfigure
1702
1703# Configuración ejemplo DHCP.
1704dhcpConfigure
1705if [ $? -ne 0 ]; then
1706        errorAndLog "Error while copying your dhcp server files!"
1707        exit 1
1708fi
1709
1710# Copiar ficheros de servicios OpenGnsys Server.
1711copyServerFiles ${INSTALL_TARGET}
1712if [ $? -ne 0 ]; then
1713        errorAndLog "Error while copying the server files!"
1714        exit 1
1715fi
1716INSTVERSION=$(jq -r '.version' $INSTALL_TARGET/doc/VERSION.json)
1717
1718# Instalar base de datos de OpenGnsys Admin.
1719isInArray notinstalled "mysql-server" || isInArray notinstalled "mariadb-server"
1720if [ $? -eq 0 ]; then
1721        # Habilitar gestor de base de datos (MySQL, si falla, MariaDB).
1722        service=$MYSQLSERV
1723        $ENABLESERVICE
1724        if [ $? != 0 ]; then
1725                service=$MARIADBSERV
1726                $ENABLESERVICE
1727        fi
1728        # Activar gestor de base de datos.
1729        $STARTSERVICE
1730        # Asignar clave del usuario "root".
1731        mysqlSetRootPassword "${MYSQL_ROOT_PASSWORD}"
1732else
1733        # Si ya está instalado el gestor de bases de datos, obtener clave de "root",
1734        mysqlGetRootPassword
1735fi
1736
1737mysqlTestConnection "${MYSQL_ROOT_PASSWORD}"
1738if [ $? -ne 0 ]; then
1739        errorAndLog "Error while connection to mysql"
1740        exit 1
1741fi
1742mysqlDbExists ${OPENGNSYS_DATABASE}
1743if [ $? -ne 0 ]; then
1744        echoAndLog "Creating Web Console database"
1745        mysqlCreateDb ${OPENGNSYS_DATABASE}
1746        if [ $? -ne 0 ]; then
1747                errorAndLog "Error while creating Web Console database"
1748                exit 1
1749        fi
1750else
1751        echoAndLog "Web Console database exists, ommiting creation"
1752fi
1753
1754mysqlCheckUserExists ${OPENGNSYS_DB_USER}
1755if [ $? -ne 0 ]; then
1756        echoAndLog "Creating user in database"
1757        mysqlCreateAdminUserToDb ${OPENGNSYS_DATABASE} ${OPENGNSYS_DB_USER} "${OPENGNSYS_DB_PASSWD}"
1758        if [ $? -ne 0 ]; then
1759                errorAndLog "Error while creating database user"
1760                exit 1
1761        fi
1762
1763fi
1764
1765mysqlCheckDbIsEmpty ${OPENGNSYS_DATABASE}
1766if [ $? -eq 0 ]; then
1767        echoAndLog "Creating tables..."
1768        if [ -f $WORKDIR/$OPENGNSYS_DB_CREATION_FILE ]; then
1769                mysqlImportSqlFileToDb ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_CREATION_FILE
1770        else
1771                errorAndLog "Unable to locate $WORKDIR/$OPENGNSYS_DB_CREATION_FILE!!"
1772                exit 1
1773        fi
1774else
1775        # Si existe fichero ogBDAdmin-VersLocal-VersRepo.sql; aplicar cambios.
1776        REPOVERSION=$(jq -r '.version' $WORKDIR/opengnsys/doc/VERSION.json)
1777        OPENGNSYS_DB_UPDATE_FILE="opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-$REPOVERSION.sql"
1778        if [ -f $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE ]; then
1779                echoAndLog "Updating tables from version $INSTVERSION to $REPOVERSION"
1780                mysqlImportSqlFileToDb ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE
1781        else
1782                echoAndLog "Database unchanged."
1783        fi
1784fi
1785# Eliminar fichero temporal con credenciales de acceso a MySQL.
1786rm -f $TMPMYCNF
1787
1788# Copiando páqinas web.
1789installWebFiles
1790# Descargar/descomprimir archivos descargables.
1791installDownloadableFiles
1792# Generar páqinas web de documentación de la API
1793makeDoxygenFiles
1794
1795# Creando configuración de Apache.
1796installWebConsoleApacheConf $INSTALL_TARGET $APACHECFGDIR
1797if [ $? -ne 0 ]; then
1798        errorAndLog "Error configuring Apache for OpenGnsys Admin"
1799        exit 1
1800fi
1801
1802popd
1803
1804# Crear la estructura de los accesos al servidor desde el cliente (shared)
1805copyClientFiles
1806if [ $? -ne 0 ]; then
1807        errorAndLog "Error creating client structure"
1808fi
1809
1810# Crear la estructura del cliente de OpenGnsys.
1811for i in $OGLIVE; do
1812        if ! clientCreate "$i"; then
1813                errorAndLog "Error creating client $i"
1814                exit 1
1815        fi
1816done
1817
1818# Configuración de servicios de OpenGnsys
1819openGnsysConfigure
1820
1821# Mostrar sumario de la instalación e instrucciones de post-instalación.
1822installationSummary
1823
1824#rm -rf $WORKDIR
1825echoAndLog "OpenGnsys installation finished at $(date)"
1826exit 0
1827
Note: See TracBrowser for help on using the repository browser.